public class mp2_2{
	public mp2_2(String[][] table1, String[][] table2, String[] columns1, String[] columns2, int[] joinOn, String[][] result){
		// Sort the tables.
		table1 = sortTable(table1, joinOn[0]);

		table2 = sortTable(table2, joinOn[1]);

		// Join the tables.
		result = blockJoin(table1, table2, joinOn, result);

		// Print column headers.
		PrintColHeaders(columns1, columns2, joinOn);

		// Print the result.
		Print(result);
	}

	// Join the two tables.  REturn the result.
	private String[][] blockJoin(String[][] table1, String[][] table2, int[] joinOn, String[][] result){
		// top is the index of the top item in the block.
		// bottom is the index of the bottom item in the block.
		// holdRow and holdCol hold our current position in the result array.
		int top = 0, bottom = -1, holdRow = 0, holdCol = 0, current = 0;

		// initialize bottom.
		String temp = table2[0][joinOn[1]];
		while (current < table2.length && table2[current][joinOn[1]].equals(temp)){
			bottom = current;
			current++;
		}

		// join the tables.  put the result in the "result" array.
		// for each item in table1,
		for (int k = 0; k < table1.length; k++){
			holdCol = 0;
			// If the value in table1 is less than the value in table2, we don't have a match 
			// so, go on to the next value in table1.
			if(table1[k][joinOn[0]].compareTo(table2[top][joinOn[1]]) < 0){
				//do nothing.
			}
			// if the values are equal, add a row to the results table.
			// continue to add results to the table until we get a different value in table2.
			else if (table1[k][joinOn[0]].equals(table2[top][joinOn[1]])){
				for (int j = top; j >= top && j <= bottom && j < table2.length; j++)
				{
					holdCol = 0;
					result[holdRow][holdCol] = table1[k][joinOn[0]];
					holdCol++;

					// add the columns from table1.
					for (int m = 0; m < table1[k].length; m++){
						if (m != joinOn[0]){
							result[holdRow][holdCol] = table1[k][m];
							holdCol++;
						}
					}

					for (int m = 0; m < table2[j].length; m++){
						if (m != joinOn[1]){
							result[holdRow][holdCol] = table2[j][m];
							holdCol++;
						}
					}

					// we have filled one row, move our current row marker.
					holdRow++;
				}
			}
			else{

				// our value is greater than the top block on the stack,
				// so we need to move the top and bottom pointers to the next block.
				if (bottom < table2.length){
					if ( bottom == table2.length - 1){
						top = bottom;
					}
					else{
						top = bottom + 1;
					}
				}
				else{
					return result;
				}
				
				int found = 0;
				// move the pointer to the bottom of the block.
				current = top;
				temp = table2[top][joinOn[1]];
				while (found == 0){
					if(current < table2.length){
						if(table2[current][joinOn[1]].equals(temp)){
							bottom = current;
							if (current == table2.length - 1){
								current = table2.length;
								found = 1;
							}
							else{
								current++;
							}
						}
						else{
							current = table2.length;
							found = 1;
						}
					}
					else{
						found = 1;
					}

				}
				current = 10;
				
				// Now that we have moved the pointers, we need to check to see if the value in 
				// table1 matches the top value in our stack.
				if (table1[k][joinOn[0]].equals(table2[top][joinOn[1]])){
					for (int j = top; (j >= top && j <= bottom) && j < table2.length; j++){
						holdCol = 0;
						result[holdRow][holdCol] = table1[k][joinOn[0]];
						holdCol++;
	
						// add the columns from table1.
						for (int m = 0; m < table1[k].length; m++){
							if (m != joinOn[0]){
								result[holdRow][holdCol] = table1[k][m];
								holdCol++;
							}
						}	
	
						for (int m = 0; m < table2[j].length; m++){
							if (m != joinOn[1]){
								result[holdRow][holdCol] = table2[j][m];
								holdCol++;
							}
						}
						
						// we have filled one row, move our current row marker.
						holdRow++;
					}
				}
			}
		}
		return result;
	}

	// Print the table.
	private void Print(String[][] array)
	{
		int isnull = 0;
		// Print table.
		for (int m = 0; m < array.length; m++)
		{
			for (int n = 0; n < array[m].length; n++)
			{
				if (array[m][n] != null)
				{
					System.out.print(array[m][n] + " ");
				}
				else
				{
					isnull = 1;
				}
			}
			if (isnull != 1)
			{
				System.out.println("");
			}
			else
			{
				isnull = 0;
			}
		}
	}

	//  Print the headers of the columns.
	private void PrintColHeaders(String[] columns1, String[] columns2, int[] joinOn){
		System.out.println(columns1[joinOn[0]]);
		
		for(int k = 0; k < columns1.length; k++){
			if(k != joinOn[0]){
				System.out.println(columns1[k]);
			}
		}

		for(int k = 0; k < columns2.length; k++){
			if(k != joinOn[1]){
				System.out.println(columns2[k]);
			}
		}
	}



	// sort the array.  Return the sorted array.
	private String[][] sortTable(String[][] table1, int joinCol){
		String[][] result = new String[table1.length][table1[0].length];

		int n = table1.length;
		for (int pass = 1; pass < n; pass++){
			for (int i = 0; i < n - pass; i++){
				if(table1[i][joinCol].compareTo(table1[i+1][joinCol]) > 0){
					String[] temp = table1[i];
					table1[i] = table1[i+1];
					table1[i+1] = temp;
				}
			}
		}
		return table1;
	}

}
